import matplotlib.pyplot as plt
import numpy as np
import math
from RNGen import *
from subprg import *
import pystan

#
#       Yasuharu Okamoto, 2016.11
#

X, n, meanSt, sgmSt, fout, nm_fout = InputData()

N = n
St = []
Res = []
for v in X:
    St.append(v[0])
    Res.append(v[1])

print('\nSt = ', St)
print('\nRes = ', Res)

Data = {'N': N, 'St': St, 'Res': Res}

minSt = St[0]
maxSt = St[0]
for v in St:
    if minSt > v:
        minSt = v
    if maxSt < v:
        maxSt = v

def i_func():
    return dict(C = [(3.0 * minSt + 2.0 * maxSt) / 5.0,
                     (2.0 * minSt + 3.0 * maxSt) / 5.0],
                sigma = (maxSt - minSt) / 2.0)

fit = pystan.stan(file = 'pf3cat.stan', data = Data, seed = 999,
                  iter = 5000, warmup = 2000, pars = ['C', 'pse', 'sigma'],
                   init = i_func, n_jobs = 1)
                      
print(fit)

mrg_sgm = fit['sigma']
mrg_C = fit['C']
mrg_C1 = []
mrg_C2 = []
for v in mrg_C:
    mrg_C1.append(v[0])
    mrg_C2.append(v[1])
        
mrg_pse = fit['pse']
    
mrg_C1.sort()
mrg_C2.sort()
mrg_pse.sort()
mrg_sgm.sort()

NSimu = len(mrg_sgm)

n = N
DispResults( NSimu, X, n, mrg_C1, mrg_C2, mrg_pse, mrg_sgm, fout )

fout.close()
print("\nOutput file {} was saved.".format(nm_fout))
    

