//      Yasuharu Okamoto, 2017.07

data {
    int N;
    real St[N];
    int<lower = 1, upper = 3> Res[N];
}

parameters {
        ordered[2] C;
        real<lower = 0.0> sigma;
}

transformed parameters {
    vector[3] p[N];
    real pse;

    pse = (C[1] + C[2]) / 2.0;

    for (i in 1:N){
        p[i][3] = Phi((St[i] - C[2]) / sigma);
        p[i][2] = Phi((St[i] - C[1]) / sigma) - Phi((St[i] - C[2]) / sigma);
        p[i][1] = 1.0 -Phi((St[i] - C[1]) / sigma);
    }
}

model {
    for (i in 1:N)
        Res[i] ~ categorical(p[i]);
}
